// this version uses millis() to manage timing rather than delay()
// and the movement is determined by a pair of momentary push switches
// press one and it turns CW, press the other one and it turns CCW

byte directionPin = 5;   // nano =2, 3216 = 1 
byte stepPin = 6;        // nono = 3,   3216 = 0  

byte buttonCWpin = 7;  // nano = A0, 3216 = 13
byte buttonCCWpin = 8;  // nano = A1, 3216 = 11

boolean buttonCWpressed = false;
boolean buttonCCWpressed = false;

byte ledPin = 17;

unsigned long curMillis;
unsigned long prevStepMillis = 0;
unsigned long millisBetweenSteps = 5; // milliseconds


//RELAY 

int RelayBUTTON = 9;   // nano A2, 3216 = 9
int relay = 10;   // nono 4,   3216 = 2
boolean flag = true;


void setup() {

     Serial.begin(9600);
     Serial.println("Starting Stepper Demo with millis()");

     pinMode(directionPin, OUTPUT);
     pinMode(stepPin, OUTPUT);
     pinMode(ledPin, OUTPUT);
     
     pinMode(buttonCWpin, INPUT_PULLUP);
     pinMode(buttonCCWpin, INPUT_PULLUP);

     // RELAY
    pinMode(relay,OUTPUT); 
    pinMode (RelayBUTTON,INPUT_PULLUP); 
     
}

void loop() {
     // Stepper
    curMillis = millis();
    readButtons();
    actOnButtons();

     //Relay
     if (digitalRead(RelayBUTTON)==LOW){ // check the state of switch1 every time we run through the main loop 
     delay(5); // I don't REALLY know why this delay helps, but it does.
      flipflop(); // hops out of main loop and runs the flipflop function
  }
   
}

void readButtons() {
   
    buttonCCWpressed = false;
    buttonCWpressed = false;
   
    if (digitalRead(buttonCWpin) == LOW) {
        buttonCWpressed = true;
    }
    if (digitalRead(buttonCCWpin) == LOW) {
        buttonCCWpressed = true;
    }
}

void actOnButtons() {
    if (buttonCWpressed == true) {
        digitalWrite(directionPin, LOW);
        singleStep();
    }
    if (buttonCCWpressed == true) {
        digitalWrite(directionPin, HIGH);
        singleStep();
    }
}

void singleStep() {
    if (curMillis - prevStepMillis >= millisBetweenSteps) {
            // next 2 lines changed 28 Nov 2018
        //prevStepMillis += millisBetweenSteps;
        prevStepMillis = curMillis;
        digitalWrite(stepPin, HIGH);
        digitalWrite(stepPin, LOW);
    }
}


void flipflop(){  //funtion flipflop
  flag = !flag;  // since we are here, the switch was pressed So FLIP the boolian "flag" state (we don't even care if switch was released yet)
  Serial.print("flag =   " );   Serial.println(flag);   // not needed, but may help to see what's happening.

  if (flag == HIGH){  // Use the value of the flag var to change the state of the pin
    digitalWrite(relay,HIGH ); // if the flag var is HIGH turn the pin on
  }
  if (flag == LOW) {
    digitalWrite(relay,LOW); // if the flag var is LOW turn the pin off
  }
  while(digitalRead(RelayBUTTON)==LOW); // for "slow" button release, keeps us in the function until button is UN-pressed
  // If you take out this "while" the function becomes a flipflop oscillator if the button is held down.
  delay(50); // OPTIONAL - play with this value.  It is probably short enough to not cause problems. deals with very quick switch press.
}
